/**
 * Provides information about a schema change event.
*/
export class IgrDataSourceDataProviderSchemaChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Represents the current schema for the data provider.
    */
    get schema() {
        return this.i.schema;
    }
    /**
     * Represents the current full count for the data provider. May be -1 if this information is not available yet.
    */
    get count() {
        return this.i.count;
    }
}
