import { Type } from "./type";
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
export declare enum DataToolTipLayerGroupingMode {
    /**
     * A grouping mode is selected automatically
     */
    Auto = 0,
    /**
     * Displays a grouped tooltip based on the primary axis if possible.
     */
    Grouped = 1,
    /**
     * Displays individual tooltips for each series.
     */
    Individual = 2
}
/**
 * @hidden
 */
export declare let DataToolTipLayerGroupingMode_$type: Type;
